
#ifdef USE_TIMED_READS
// try to use some teensy core functions...
// mainly out of pwm.c
extern "C" {
  extern void xbar_connect(unsigned int input, unsigned int output);
  extern void quadtimer_init(IMXRT_TMR_t *p);
  extern void quadtimerWrite(IMXRT_TMR_t *p, unsigned int submodule, uint16_t val);
  extern void quadtimerFrequency(IMXRT_TMR_t *p, unsigned int submodule, float frequency);
}


void connectTimer(uint8_t timer, uint8_t trigger_group)
{

  //Initialize QuadTimer
  quadtimer_init(&IMXRT_TMR4);
  //Turn on XBARA1 clock
  CCM_CCGR2 |= CCM_CCGR2_XBAR1(CCM_CCGR_ON);   //turn clock on for xbara1
    
  Serial.printf("Timer: %d, Trigger: %d\n", timer, trigger_group);
  switch (trigger_group)
  {
    case 0:
      if(timer == 1){
        xbar_connect(XBARA1_IN_QTIMER4_TIMER3, XBARA1_OUT_ADC_ETC_TRIG00);   // pit to adc_etc
      } else {
        xbar_connect(XBARA1_IN_QTIMER4_TIMER0, XBARA1_OUT_ADC_ETC_TRIG00);   // pit to adc_etc
      }
      break;
    case 1:
      if(timer == 1){
        xbar_connect(XBARA1_IN_QTIMER4_TIMER3, XBARA1_OUT_ADC_ETC_TRIG01);   // pit to adc_etc
      } else {
        xbar_connect(XBARA1_IN_QTIMER4_TIMER0, XBARA1_OUT_ADC_ETC_TRIG01);   // pit to adc_etc
      }     break;
    case 2:
      if(timer == 1){
        xbar_connect(XBARA1_IN_QTIMER4_TIMER3, XBARA1_OUT_ADC_ETC_TRIG02);   // pit to adc_etc
      } else {
        xbar_connect(XBARA1_IN_QTIMER4_TIMER0, XBARA1_OUT_ADC_ETC_TRIG02);   // pit to adc_etc
      }     break;
    case 3:
      if(timer == 1){
        xbar_connect(XBARA1_IN_QTIMER4_TIMER3, XBARA1_OUT_ADC_ETC_TRIG03);   // pit to adc_etc
      } else {
        xbar_connect(XBARA1_IN_QTIMER4_TIMER0, XBARA1_OUT_ADC_ETC_TRIG03);   // pit to adc_etc
      }     break;
    case 4:
      if(timer == 1){
        xbar_connect(XBARA1_IN_QTIMER4_TIMER3, XBARA1_OUT_ADC_ETC_TRIG10);   // pit to adc_etc
      } else {
        xbar_connect(XBARA1_IN_QTIMER4_TIMER0, XBARA1_OUT_ADC_ETC_TRIG10);   // pit to adc_etc
      }     break;
    case 5:
      if(timer == 1){
        xbar_connect(XBARA1_IN_QTIMER4_TIMER3, XBARA1_OUT_ADC_ETC_TRIG11);   // pit to adc_etc
      } else {
        xbar_connect(XBARA1_IN_QTIMER4_TIMER0, XBARA1_OUT_ADC_ETC_TRIG11);   // pit to adc_etc
      }     break;
    case 6:
      if(timer == 1){
        xbar_connect(XBARA1_IN_QTIMER4_TIMER3, XBARA1_OUT_ADC_ETC_TRIG12);   // pit to adc_etc
      } else {
        xbar_connect(XBARA1_IN_QTIMER4_TIMER0, XBARA1_OUT_ADC_ETC_TRIG12);   // pit to adc_etc
      }     break;
    case 7:
      if(timer == 1){
        xbar_connect(XBARA1_IN_QTIMER4_TIMER3, XBARA1_OUT_ADC_ETC_TRIG13);   // pit to adc_etc
      } else {
        xbar_connect(XBARA1_IN_QTIMER4_TIMER0, XBARA1_OUT_ADC_ETC_TRIG13);   // pit to adc_etc
      }     break;
    default:
      break;
  }
}

void startTimer(uint8_t timer, float freq)
{
  Serial.printf("Timer: %d, Freq: %f\n", timer, freq);
  if(timer == 1){
    //CCM_CCGR1 |= CCM_CCGR1_PIT(CCM_CCGR_ON);
    //PIT_MCR = 0;
    //IMXRT_PIT_CHANNELS[0].LDVAL = freq;
    //IMXRT_PIT_CHANNELS[0].TCTRL = PIT_TCTRL_TEN;
    Serial.println("Try to init QTimer4_3"); Serial.flush();
    //quadtimer_init(&IMXRT_TMR4);
    quadtimerFrequency(&IMXRT_TMR4, 3, freq);
    quadtimerWrite(&IMXRT_TMR4, 3, 5);

    Serial.println("After Qtimer4_3 init"); Serial.flush();
    
  } else {
    Serial.println("Try to init QTimer4_0"); Serial.flush();
    //quadtimer_init(&IMXRT_TMR4);
    quadtimerFrequency(&IMXRT_TMR4, 0, freq);
    quadtimerWrite(&IMXRT_TMR4, 0, 5);

    Serial.println("After Qtimer4_0 init"); Serial.flush();
  }
}
#endif

void adcetc0_isr() {
  digitalWriteFast(LED_BUILTIN, !digitalReadFast(LED_BUILTIN));
  ADC_ETC_DONE0_1_IRQ |= 1 << trigger_adc_0;   // clear
  ADC_ETC_DONE0_1_IRQ |= 1 << trigger_adc_1;   // clear
  //val0 = ADC_ETC_TRIG0_RESULT_1_0 & 4095;
  for(uint8_t i=0; i < chain_len_0; i++) {
    adcValues_0[i] = ADC_ETC_GetADCConversionValue( trigger_adc_0, i ); /* Get trigger0 chain0 result. */
  }
  for(uint8_t i=0; i < chain_len_1; i++) {
    adcValues_1[i] = ADC_ETC_GetADCConversionValue( trigger_adc_1, i );
  }

  asm("dsb");
}

void adcetc1_isr() {
  digitalWriteFast(LED_BUILTIN, !digitalReadFast(LED_BUILTIN));
  ADC_ETC_DONE0_1_IRQ |= 1 << trigger_adc_0;   // clear
  ADC_ETC_DONE0_1_IRQ |= 1 << trigger_adc_1;   // clear
  //val0 = ADC_ETC_TRIG0_RESULT_1_0 & 4095;
  for(uint8_t i=0; i < chain_len_0; i++) {
    adcValues_0[i] = ADC_ETC_GetADCConversionValue( trigger_adc_0, i ); /* Get trigger0 chain0 result. */
  }
  for(uint8_t i=0; i < chain_len_1; i++) {
    adcValues_1[i] = ADC_ETC_GetADCConversionValue( trigger_adc_1, i );
  }

  asm("dsb");
}

void adc_etc_reset(){
  //  first do soft reset and/or let complete
  IMXRT_ADC_ETC.CTRL = ADC_ETC_CTRL_SOFTRST; // SOFTRST
  IMXRT_ADC_ETC.CTRL &= ~ADC_ETC_CTRL_SOFTRST; // SOFTRST
  delay(5);
}

void adc0_etc_ctrl_init(uint8_t chainLength_0,
                  int adc_0_pinArray[], 
                  uint8_t trigger_adc_0, bool DMA) 
{
  int numPins_adc_0 = sizeof(adc_0_pinArray);
  uint8_t adc_pin_channel, res;

  delay(5);
  
  // Now lets process ADC1(ADC_0) pin...
  
  for(uint8_t i = 0; i < numPins_adc_0; i++){
    // check pins
    if ( !adc->adc0->checkPin(adc_0_pinArray[i]) ) {
        Serial.printf("ADC_ETC_INIT: pin:%d did not map to channnel on %d\n", adc_0_pinArray[i], ADC_0);
        adc->adc0->fail_flag |= ADC_ERROR::WRONG_PIN;
        return res;
    }
    //adc_pin_channel = mapPinToChannel(adc_0_pinArray[i], ADC_0);
    //if (adc_pin_channel == 0xff) 
    //  Serial.printf("ADC_ETC_INIT: pin:%d did not map to channnel on %d\n", adc_0_pinArray[i], ADC_0);
  }
  IMXRT_ADC_ETC.CTRL = (ADC_ETC_CTRL_DMA_MODE_SEL | ADC_ETC_CTRL_TRIG_ENABLE(1<<trigger_adc_0)); // 0x40000001;  // start with trigger 0
  IMXRT_ADC_ETC.TRIG[trigger_adc_0].CTRL = ADC_ETC_TRIG_CTRL_TRIG_CHAIN(chainLength_0-1);

  if(DMA)
    IMXRT_ADC_ETC.DMA_CTRL = ADC_ETC_DMA_CTRL_TRIQ_ENABLE(trigger_adc_0);
  Serial.printf("ADC1: HC0:%x HS:%x CFG:%x GC:%x GS:%x\n", ADC1_HC0, ADC1_HS,  ADC1_CFG, ADC1_GC, ADC1_GS);
  Serial.printf("ADC_ETC: CTRL:%x DMA: %x TRIG0: CTRL: %x CHAIN01:%x\n",
                IMXRT_ADC_ETC.CTRL, IMXRT_ADC_ETC.DMA_CTRL, ADC_ETC_TRIG0_CTRL, ADC_ETC_TRIG0_CHAIN_1_0);

}

void adc1_etc_ctrl_init(uint8_t chainLength_1,
                  int adc_1_pinArray[], 
                  uint8_t trigger_adc_1, bool DMA) 
{
  int numPins_adc_1 = sizeof(adc_1_pinArray);
  uint8_t adc_pin_channel, res;

  delay(5);
  
  // Now lets do ADC2(ADC_1)
  if(chainLength_1 >= 0){
  for(uint8_t i = 0; i < numPins_adc_1; i++){
    // check pins
    if ( !adc->adc1->checkPin(adc_1_pinArray[i]) ) {
        Serial.printf("ADC_ETC_INIT: pin:%d did not map to channnel on %d\n", adc_1_pinArray[i], ADC_1);
        adc->adc1->fail_flag |= ADC_ERROR::WRONG_PIN;
        return res;
    }
    //adc_pin_channel = mapPinToChannel(adc_1_pinArray[i], ADC_1);
    //if (adc_pin_channel == 0xff) 
    //  Serial.printf("ADC_ETC_INIT: pin:%d did not map to channnel on %d\n", adc_1_pinArray[i], ADC_1);
  }
  // ADC2 (ADC_1)
  IMXRT_ADC_ETC.CTRL |= ADC_ETC_CTRL_TRIG_ENABLE(1 << trigger_adc_1); // Add in our trigger
  Serial.printf("ADC_ETC_CTRL: %x\n",  IMXRT_ADC_ETC.CTRL);
  
  IMXRT_ADC_ETC.TRIG[trigger_adc_1].CTRL = ADC_ETC_TRIG_CTRL_TRIG_CHAIN(chainLength_1-1);
  
  if(DMA)
    IMXRT_ADC_ETC.DMA_CTRL |= ADC_ETC_DMA_CTRL_TRIQ_ENABLE(trigger_adc_1);
  }

  Serial.printf("ADC2: HC0:%x HS:%x CFG:%x GC:%x GS:%x\n", ADC2_HC0, ADC2_HS,  ADC2_CFG, ADC2_GC, ADC2_GS);
  Serial.printf("ADC_ETC: CTRL:%x DMA: %x TRIG0: CTRL: %x CHAIN01:%x\n",
                IMXRT_ADC_ETC.CTRL, IMXRT_ADC_ETC.DMA_CTRL, ADC_ETC_TRIG0_CTRL, ADC_ETC_TRIG0_CHAIN_1_0);

}

void ADC_ETC_SetTriggerChainConfig(uint8_t adc_num, 
                                   uint32_t triggerGroup,
                                   uint32_t chainGroup, //0, 1, 2, 3 (0_1, 3_2....
                                   uint8_t pin1, uint8_t pin2)
{
   uint8_t adc_pin_channel, res;

    switch (chainGroup)
    {
      case 0U: /* Configurate trigger chain0 and chain 1. */
        if(adc_num == 1) {
          adc_pin_channel = ADC::channel2sc1aADC1[pin1];
        } else {
          adc_pin_channel = ADC::channel2sc1aADC0[pin1];
        }
        IMXRT_ADC_ETC.TRIG[triggerGroup].CHAIN_1_0 |= ADC_ETC_TRIG_CHAIN_B2B0 |
        ADC_ETC_TRIG_CHAIN_IE0(1) /*| ADC_ETC_TRIG_CHAIN_B2B0 */
          | ADC_ETC_TRIG_CHAIN_HWTS0(1) | ADC_ETC_TRIG_CHAIN_CSEL0(adc_pin_channel) ;

        if(pin2 > -1)
        {
          if(adc_num == 1) {
            adc_pin_channel = ADC::channel2sc1aADC1[pin2];
          } else {
            adc_pin_channel = ADC::channel2sc1aADC0[pin2];
          }
          IMXRT_ADC_ETC.TRIG[triggerGroup].CHAIN_1_0 |= ADC_ETC_TRIG_CHAIN_B2B1 | 
            ADC_ETC_TRIG_CHAIN_IE1(1) /*| ADC_ETC_TRIG_CHAIN_B2B0 */
            | ADC_ETC_TRIG_CHAIN_HWTS1(1) | ADC_ETC_TRIG_CHAIN_CSEL1(adc_pin_channel); 
        }
        break;
      case 1U: /* Configurate trigger chain2 and chain 3. */
        if(adc_num == 1) {
          adc_pin_channel = ADC::channel2sc1aADC1[pin1];
        } else {
          adc_pin_channel = ADC::channel2sc1aADC0[pin1];
        }
        //Serial.print("ADC Pin3 Channel: "); Serial.println(adc_pin_channel);
        IMXRT_ADC_ETC.TRIG[triggerGroup].CHAIN_3_2 = 
          ADC_ETC_TRIG_CHAIN_B2B0 |
          ADC_ETC_TRIG_CHAIN_IE0(1) /*| ADC_ETC_TRIG_CHAIN_B2B0 */
          | ADC_ETC_TRIG_CHAIN_HWTS0(1) | ADC_ETC_TRIG_CHAIN_CSEL0(adc_pin_channel) ;
        if(pin2 > -1)
        {
          if(adc_num == 1) {
            adc_pin_channel = ADC::channel2sc1aADC1[pin2];
          } else {
            adc_pin_channel = ADC::channel2sc1aADC0[pin2];
          }
        //Serial.print("ADC Pin4 Channel: "); Serial.println(adc_pin_channel);
          IMXRT_ADC_ETC.TRIG[triggerGroup].CHAIN_3_2 |= ADC_ETC_TRIG_CHAIN_B2B1 | 
            ADC_ETC_TRIG_CHAIN_IE1(1) /*| ADC_ETC_TRIG_CHAIN_B2B0 */
            | ADC_ETC_TRIG_CHAIN_HWTS1(1) | ADC_ETC_TRIG_CHAIN_CSEL1(adc_pin_channel); 
            //Serial.print("TRIG[0].CHAIN_3_2: "); Serial.println(IMXRT_ADC_ETC.TRIG[0].CHAIN_3_2, HEX);
        }
        break;
      case 2U: /* Configurate trigger chain4 and chain 5. */
        if(adc_num == 1) {
          adc_pin_channel = ADC::channel2sc1aADC1[pin1];
        } else {
          adc_pin_channel = ADC::channel2sc1aADC0[pin1];
        }
        IMXRT_ADC_ETC.TRIG[triggerGroup].CHAIN_5_4 = 
          ADC_ETC_TRIG_CHAIN_B2B0 |
          ADC_ETC_TRIG_CHAIN_IE0(1) /*| ADC_ETC_TRIG_CHAIN_B2B0 */
          | ADC_ETC_TRIG_CHAIN_HWTS0(1) | ADC_ETC_TRIG_CHAIN_CSEL0(adc_pin_channel) ;
        if(pin2 > -1)
          {
          if(adc_num == 1) {
            adc_pin_channel = ADC::channel2sc1aADC1[pin2];
          } else {
            adc_pin_channel = ADC::channel2sc1aADC0[pin2];
          }
          IMXRT_ADC_ETC.TRIG[triggerGroup].CHAIN_5_4 |= ADC_ETC_TRIG_CHAIN_B2B1 | 
            ADC_ETC_TRIG_CHAIN_IE1(1) /*| ADC_ETC_TRIG_CHAIN_B2B0 */
            | ADC_ETC_TRIG_CHAIN_HWTS1(1) | ADC_ETC_TRIG_CHAIN_CSEL1(adc_pin_channel); 
        }
         break;
      case 3U: /* Configurate trigger chain6 and chain 7. */
        if(adc_num == 1) {
          adc_pin_channel = ADC::channel2sc1aADC1[pin1];
        } else {
          adc_pin_channel = ADC::channel2sc1aADC0[pin1];
        }
        IMXRT_ADC_ETC.TRIG[triggerGroup].CHAIN_7_6 = 
          ADC_ETC_TRIG_CHAIN_B2B0 |
          ADC_ETC_TRIG_CHAIN_IE0(1) /*| ADC_ETC_TRIG_CHAIN_B2B0 */
          | ADC_ETC_TRIG_CHAIN_HWTS0(1) | ADC_ETC_TRIG_CHAIN_CSEL0(adc_pin_channel) ;
        if(pin2 > -1)
        {
          if(adc_num == 1) {
            adc_pin_channel = ADC::channel2sc1aADC1[pin2];
          } else {
            adc_pin_channel = ADC::channel2sc1aADC0[pin2];
          }
          IMXRT_ADC_ETC.TRIG[triggerGroup].CHAIN_7_6 |= ADC_ETC_TRIG_CHAIN_B2B1 | 
            ADC_ETC_TRIG_CHAIN_IE1(1) /*| ADC_ETC_TRIG_CHAIN_B2B0 */
            | ADC_ETC_TRIG_CHAIN_HWTS1(1) | ADC_ETC_TRIG_CHAIN_CSEL1(adc_pin_channel); 
        }
         break;
      default:
         break;
    }
}


/*!
* Taken from SDK
* brief Get ADC conversion result from external XBAR sources.
* For example, if triggerGroup is set to 0U and chainGroup is set to 1U, which means the API would
* return Trigger0 source's chain1 conversion result.
*
* param base ADC_ETC peripheral base address.
* param triggerGroup Trigger group index. Available number is 0~7.
* param chainGroup Trigger chain group index. Available number is 0~7.
* return ADC conversion result value.
*/
uint32_t ADC_ETC_GetADCConversionValue(uint32_t triggerGroup, uint32_t chainGroup)
{
    //assert(triggerGroup < ADC_ETC_TRIGn_RESULT_1_0_COUNT);

    uint32_t mADCResult;
    uint8_t mRemainder = chainGroup % 2U;

    switch (chainGroup / 2U)
    {
        case 0U:
            if (0U == mRemainder)
            {
                mADCResult = (0xFFFU) & (IMXRT_ADC_ETC.TRIG[triggerGroup].RESULT_1_0);
            }
            else
            {
                mADCResult = (IMXRT_ADC_ETC.TRIG[triggerGroup].RESULT_1_0) >> (16U);
            }
            break;
        case 1U:
            if (0U == mRemainder)
            {
                mADCResult = (0xFFFU) & (IMXRT_ADC_ETC.TRIG[triggerGroup].RESULT_3_2);
            }
            else
            {
                mADCResult = (IMXRT_ADC_ETC.TRIG[triggerGroup].RESULT_3_2) >> (16U);
            }
            break;
        case 2U:
            if (0U == mRemainder)
            {
                mADCResult = (0xFFFU) & (IMXRT_ADC_ETC.TRIG[triggerGroup].RESULT_5_4);
            }
            else
            {
                mADCResult = (IMXRT_ADC_ETC.TRIG[triggerGroup].RESULT_5_4) >> (16U);
            }
            break;
        case 3U:
            if (0U == mRemainder)
            {
                mADCResult = (0xFFFU) & (IMXRT_ADC_ETC.TRIG[triggerGroup].RESULT_7_6);
            }
            else
            {
                mADCResult = (IMXRT_ADC_ETC.TRIG[triggerGroup].RESULT_7_6) >> (16U);
            }
            break;
        default:
            return 0U;
    }
    return mADCResult;
}
